poj 2923 Relocation(状压dp,好题)

来源:互联网 发布:巨人网络股票估值多少 编辑:程序博客网 时间:2024/04/30 00:43

题目链接
Relocation
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 3209 Accepted: 1305

Description

Emma and Eric are moving to their new house they bought after returning from their honeymoon. Fortunately, they have a few friends helping them relocate. To move the furniture, they only have two compact cars, which complicates everything a bit. Since the furniture does not fit into the cars, Eric wants to put them on top of the cars. However, both cars only support a certain weight on their roof, so they will have to do several trips to transport everything. The schedule for the move is planed like this:

  1. At their old place, they will put furniture on both cars.
  2. Then, they will drive to their new place with the two cars and carry the furniture upstairs.
  3. Finally, everybody will return to their old place and the process continues until everything is moved to the new place.

Note, that the group is always staying together so that they can have more fun and nobody feels lonely. Since the distance between the houses is quite large, Eric wants to make as few trips as possible.

Given the weights wi of each individual piece of furniture and the capacities C1 and C2 of the two cars, how many trips to the new house does the party have to make to move all the furniture? If a car has capacity C, the sum of the weights of all the furniture it loads for one trip can be at most C.

Input

The first line contains the number of scenarios. Each scenario consists of one line containing three numbers nC1 and C2C1 and C2 are the capacities of the cars (1 ≤ Ci ≤ 100) and n is the number of pieces of furniture (1 ≤ n ≤ 10). The following line will contain n integers w1, …, wn, the weights of the furniture (1 ≤ wi ≤ 100). It is guaranteed that each piece of furniture can be loaded by at least one of the two cars.

Output

The output for every scenario begins with a line containing “Scenario #i:”, where i is the number of the scenario starting at 1. Then print a single line with the number of trips to the new house they have to make to move all the furniture. Terminate each scenario with a blank line.

Sample Input

26 12 133 9 13 3 10 117 1 1001 2 33 50 50 67 98

Sample Output

Scenario #1:2Scenario #2:3

Source

TUD Programming Contest 2006, Darmstadt, Germany



题意: 有 n 个货物,并且知道了每个货物的重量,每次用载重量分别为c1,c2的火车装载,问最少需要运送多少次可以将货物运完。


题解:

解法为状态压缩DP+背包,本题的解题思路是先枚举选择若干个时的状态,总状态量为1<<n,判断这些状态集合里的那些物品能否一次就运走,如果能运走,那就把这个状态看成一个物品。预处理完能从枚举中找到tol个物品,再用这tol个物品中没有交集(也就是两个状态不能同时含有一个物品)的物品进行01背包,每个物品的体积是state[i],价值是1,求包含n个物品的最少价值也就是dp[(1<<n)-1](dp[i]表示状态i需要运的最少次数)。


状态转移方程:dp[j|k] = min(dp[j|k],dp[k]+1) (k为state[i,1<=j<=(1<<n)-1])。
算法复杂度O((2^N)*N)



#include<iostream>#include<cstdio>#include<algorithm>#include<cstring>using namespace std;const int MAXN=(1<<10)+10;const int INF=0x3f3f3f3f;int a[15],d[MAXN],vis[110];int state[1100];int n,C1,C2;bool check(int x){memset(vis,0,sizeof(vis));vis[0]=1;int sum=0;for(int i=0;i<n;i++)if(x&(1<<i)){sum+=a[i];for(int j=C1;j>=a[i];j--)if(vis[j-a[i]])                            //vis[j]=vis[j-a[i]];vis[j]=1;}if(sum>C1+C2) return false;for(int j=C1;j>=0;j--) if(vis[j]&&C2>=sum-j) return true;return false;}int main(){int cas;scanf("%d",&cas);for(int k=1;k<=cas;k++){int tol=0;scanf("%d%d%d",&n,&C1,&C2);for(int i=0;i<n;i++) scanf("%d",&a[i]);int tot=(1<<n)-1;for(int i=0;i<=tot;i++){if(check(i)) state[tol++]=i;d[i]=INF;}d[0]=0;for(int i=0;i<tol;i++){for(int j=tot;j>=0;j--){if((j&state[i])==0){d[j|state[i]]=min(d[j|state[i]],d[j]+1);}}}printf("Scenario #%d:\n%d\n\n",k,d[tot]);}}



















0 0
原创粉丝点击